<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="问题" prop="title">
        <el-input
          v-model="queryParams.title"
          placeholder="请输入问题标题"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
<!--      <el-form-item label="排序" prop="sort">-->
<!--        <el-input-->
<!--          v-model="queryParams.sort"-->
<!--          placeholder="请输入排序"-->
<!--          clearable-->
<!--          size="small"-->
<!--          @keyup.enter.native="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item label="类别" prop="type">
        <el-select v-model="queryParams.type" placeholder="请选择类别" clearable size="small">
          <el-option
            v-for="dict in typeOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
		<el-form-item label="题目类别" prop="questionType">
	    <el-select v-model="queryParams.questionType" placeholder="请选择类别" @change="changeCateType" clearable size="small">
	      <el-option
	        v-for="dict in questionRootTypeOptions"
	        :key="dict.dictValue"
	        :label="dict.dictLabel"
	        :value="dict.dictValue"
	      />
	    </el-select>
	  </el-form-item>
      <el-form-item label="题目子类别" prop="questionSubType" label-width="100px">
        <el-select v-model="queryParams.questionSubType" ref="typeSelect" placeholder="请选择子类别" clearable size="small">
          <el-option
            v-for="item in questionSubTypeOptions"
            :key="item.dictValue"
            :label="item.dictLabel"
            :value="item.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-table border v-loading="loading" ref="table"   :data="courseQuestionBankList" >
<!--      <el-table-column type="selection" width="55" align="center"/>-->
      <el-table-column label="标题" align="center" prop="title" >
        <template slot-scope="scope">
          <el-tooltip class="item" effect="dark" :content="scope.row.title" placement="top">
            <div style="display: -webkit-box; -webkit-box-orient: vertical; -webkit-line-clamp: 3; overflow: hidden; text-overflow: ellipsis;">
              <span>{{ scope.row.title }}</span>
            </div>
          </el-tooltip>
        </template>
      </el-table-column>
      <el-table-column label="类别" align="center" prop="type">
        <template slot-scope="scope">
          <dict-tag :options="typeOptions" :value="scope.row.type"/>
        </template>
      </el-table-column>
	  <el-table-column label="题目类别" align="center" prop="questionType">
	    <template slot-scope="scope">
	      <dict-tag :options="questionTypeOptions" :value="scope.row.questionType"/>
	    </template>
	  </el-table-column>
      <el-table-column label="状态" align="center" prop="status">
        <template slot-scope="scope">
          <dict-tag :options="statusOptions" :value="scope.row.status"/>
        </template>
      </el-table-column>
      <el-table-column label="排序" align="center" prop="sort" />
      <el-table-column label="答案" align="center" prop="answer" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="chooseQuestion(scope.row)"
            v-hasPermi="['course:courseQuestionBank:edit']"
          >选择此题</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改题库对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="1000px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="标题" prop="title">
          <el-input v-model="form.title" placeholder="请输入问题" />
        </el-form-item>
        <el-form-item label="排序" prop="sort">
          <el-input-number v-model="form.sort"  :min="0" label="请输入排序"></el-input-number>
        </el-form-item>
        <el-form-item label="题目类别 " prop="type">
          <el-select v-model="form.type" placeholder="请选择题目类别" @change="changeType">
            <el-option
              v-for="dict in typeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="parseInt(dict.dictValue)"
            ></el-option>
          </el-select>
        </el-form-item>
<!--        <el-form-item label="状态">-->
<!--          <el-radio-group v-model="form.status">-->
<!--            <el-radio-->
<!--              v-for="dict in statusOptions"-->
<!--              :key="dict.dictValue"-->
<!--              :label="parseInt(dict.dictValue)"-->
<!--            >{{dict.dictLabel}}</el-radio>-->
<!--          </el-radio-group>-->
<!--        </el-form-item>-->
        <!-- 提示用户选择类别 -->
        <el-alert v-if="!form.type" title="选择题目类别后添加选项" type="warning" show-icon></el-alert>

        <el-form-item label="选项"  v-if="form.type">
          <el-table :data="question"  :cell-style="{ textAlign: 'center' }"		 :header-cell-style="{textAlign: 'center'}"   >
            <el-table-column label="序号" width="65px" >
              <template slot-scope="scope">
                {{ '选项'+getOptionLabel(scope.$index)+':' }}
              </template>
            </el-table-column>
            <el-table-column label="选项" prop="name" >
              <template slot-scope="scope">
                <el-input v-model="scope.row.name" :placeholder="getOptionLabel(scope.$index) + '：' + '请输入标题'" ></el-input>
              </template>
            </el-table-column>
            <el-table-column label="是否为答案" prop="isWrite" >
              <template slot-scope="scope">
                <el-tooltip
                  v-if="!scope.row.name"
                  content="请先填写选项标题内容"
                  placement="top"
                  effect="dark"
                >
                  <el-switch
                    v-model="scope.row.isAnswer"
                    :active-value="1"
                    :inactive-value="0"
                    @change="handleAnswerChange(scope.row,scope.$index)"
                    :disabled="Boolean(!scope.row.name || (form.type === 1 && scope.row.isAnswer && selectedAnswer !== scope.row))"
                  ></el-switch>
                </el-tooltip>
                <el-switch
                  v-else
                  v-model="scope.row.isAnswer"
                  :active-value="1"
                  :inactive-value="0"
                  @change="handleAnswerChange(scope.row,scope.$index)"
                  :disabled="Boolean(form.type === 1 && scope.row.isAnswer && selectedAnswer !== scope.row)"
                ></el-switch>
              </template>
            </el-table-column>
            <el-table-column label="操作">
              <template slot-scope="scope">
                <el-button @click="deleteRow(scope.$index)"   size="mini" type="text" v-if="question.length>1">删除</el-button>
                <el-button @click="addRow(scope.$index+1)" size="mini" type="text" >新增</el-button>
              </template>
            </el-table-column>
          </el-table>
        </el-form-item>
        <el-form-item label="答案:" prop="answer">
          <template slot-scope="scope">
            <span style="background-color: #faedc9; font-size: 20px;">
              {{ form.answer }}
            </span>
          </template>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listCourseQuestionBank, getCourseQuestionBank, delCourseQuestionBank, addCourseQuestionBank, updateCourseQuestionBank, exportCourseQuestionBank } from "@/api/course/courseQuestionBank";
import { getCateListByPid, getCatePidList, listUserCourseCategory } from '@/api/course/userCourseCategory'

export default {
  name: "CourseQuestionBank",
  computed: {
    alphabet() {
      return 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    },
  },
  watch: {
  },
  mounted() {
  },
  data() {
    return {

      //单选
      selectedAnswer:null,
      //多选
      selectedAnswers: [],

      typeOptions: [],
      statusOptions: [],
      question:[
        { name: "", isAnswer: 0, indexId:0},
      ],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 题库表格数据
      courseQuestionBankList: [],
	  questionTypeOptions: [],
      questionRootTypeOptions: [],
      questionSubTypeOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        title: null,
        sort: null,
        type: null,
        status: null,
        question: null,
		questionType: null,
        questionSubType: null,
        answer: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        title: [{ required: true, message: "不能为空", trigger: "blur" }],
        sort: [{ required: true, message: "不能为空", trigger: "blur" }],
        type: [{ required: true, message: "不能为空", trigger: "blur" }],
        status: [{ required: true, message: "不能为空", trigger: "blur" }],
        question: [{ required: true, message: "不能为空", trigger: "blur" }],
        answer: [{ required: true, message: "不能为空", trigger: "blur" }],
      }
    };
  },
  created() {
    this.getList();
    this.getDicts("sys_course_temp_type").then(response => {
      this.typeOptions = response.data;
    });
    this.getDicts("sys_company_status").then(response => {
      this.statusOptions = response.data;
    });
	this.getDicts("sys_course_question_type").then(response => {
	  this.questionTypeOptions = response.data;
	});
    this.getCategoryType()
  },
  methods: {
    getOptionLabel(index) {
      return this.alphabet[index];
    },
    getCategoryType() {
      getCatePidList().then(response => {
        this.questionRootTypeOptions = response.data
      });
    },
    changeCateType(val) {
      this.questionSubTypeOptions = []
      this.queryParams.questionSubType = null
      if (!val) {
        return
      }
      getCateListByPid(val).then(response => {
        this.questionSubTypeOptions = response.data
      })
    },
    //选择此课
    chooseQuestion(val){
      this.$emit('questionBankResult',val)
    },
    //题目类型发生变化
    changeType(){
        this.selectedAnswers = [];
        this.selectedAnswer = null;
        this.question.forEach(item => {
          item.isAnswer = 0; // 清除所有选项的选中状态
        });
        // 重置答案的显示值
        this.form.answer = null;
    },
    //选择答案
    handleAnswerChange(row, index) {
      if (this.form.type === 1) {
        // 单选模式：记录选中的答案并取消其他选项
        this.selectedAnswer = row;
        this.question.forEach((item) => {
          if (item !== row) {
            item.isAnswer = 0;
          }
        });
        // 保存单选的答案
        // this.form.answer = this.getOptionLabel(index);
        this.form.answer = row.name;
      } else if (this.form.type === 2) {

        // 多选模式：将所有被选中的答案存储到 selectedAnswers 数组 先检查当前选项是否已经在选中答案列表中
        if (row.isAnswer === 1) {
          // 如果选中，将该答案加入到选中数组
          this.selectedAnswers.push(row);
        } else {
          // 如果取消选中，从选中数组中移除
          this.selectedAnswers = this.selectedAnswers.filter(item => item.indexId !== row.indexId);
        }

        // 对 selectedAnswers 进行排序 (假设按 row.indexId 排序)
        this.selectedAnswers.sort((a, b) => a.indexId - b.indexId);

        // 更新 form.answer，保存所有选中的答案
        this.form.answer = this.selectedAnswers.map(item => item.name);
      }

    },
    addRow(val) {
      this.question.push({ name: '', isAnswer: 0,indexId:val});},
    deleteRow(index) {
      if (this.form.type === 1 && this.question[index] === this.selectedAnswer) {
        this.selectedAnswer = null;
      }
      this.question.splice(index, 1);
    },
    /** 查询题库列表 */
    getList() {
      this.loading = true;
      listCourseQuestionBank(this.queryParams).then(response => {
        this.courseQuestionBankList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        title: null,
        sort: null,
        type: 1,
        status: 1,
        question: null,
        createTime: null,
        answer: null,
        createBy: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },

    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },

    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加题库";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getCourseQuestionBank(id).then(response => {
        this.form = response.data;


        //初始化多选的选择结果，单选的选择的时候，就取消其他的了 selectedAnswers
        if (this.form.type===2) {
          this.form.answer=JSON.parse(this.form.answer)
          this.selectedAnswers = JSON.parse(this.form.question).filter(item => item.isAnswer === 1);
        }

        this.question=JSON.parse(this.form.question)
        this.open = true;
        this.title = "修改题库";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.question=JSON.stringify(this.question)

          if (this.form.type===2){
            this.form.answer=JSON.stringify(this.form.answer)
          }
          if (this.form.id != null) {
            updateCourseQuestionBank(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {

            addCourseQuestionBank(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除题库编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delCourseQuestionBank(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有题库数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportCourseQuestionBank(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
